Index: lexer.c
===================================================================
RCS file: /cvsroot/bogofilter/bogofilter/src/lexer.c,v
retrieving revision 1.98
diff -u -r1.98 lexer.c
--- lexer.c	8 Jul 2004 13:08:18 -0000	1.98
+++ lexer.c	9 Oct 2004 00:10:53 -0000
@@ -287,24 +287,42 @@
     return (count == EOF ? 0 : count);
 }
 
+void *memmem(void *haystack, size_t haystacklen,
+	     const void *needle, size_t needlelen);
+
+void *memmem(void *haystack, size_t haystacklen,
+	     const void *needle, size_t needlelen)
+{
+    char  *tmp = haystack;
+    size_t pos = haystacklen - needlelen;
+    while (pos > 0) {
+	if (memcmp(tmp, needle, needlelen) == 0)
+	    return tmp;
+	else
+	    tmp += 1;
+    }
+    return NULL;
+}
+
 size_t text_decode(word_t *w)
 {
     byte *beg = w->text;
+    uint leng = w->leng;
     byte *fin = beg + w->leng;
-    byte *txt = (byte *) strstr((char *)beg, "=?");	/* skip past leading text */
+    byte *txt = (byte *) memmem((char *)beg, leng, "=?", 2);	/* skip past leading text */
     uint size = (uint) (txt - beg);
 
     while (txt < fin) {
 	word_t n;
-	byte *typ = (byte *) strchr((char *)txt+2, '?');/* Encoding type - 'B' or 'Q' */
+	byte *typ = (byte *) strchr((char *)txt+2, '?');	/* Encoding type - 'B' or 'Q' */
 	byte *tmp = typ + 3;
-	byte *end = (byte *) strstr((char *)tmp, "?=");	/* last byte of encoded word  */
+	byte *end = (byte *) memmem((char *)tmp, leng - (tmp-beg), "?=", 2);	/* last byte of encoded word  */
 	uint len = end - tmp;
 	bool copy;
 
 	n.text = tmp;				/* Start of encoded word */
 	n.leng = len;				/* Length of encoded word */
-	n.text[n.leng] = (byte) '\0';
+	Z(n.text[n.leng]);
 
 	if (DEBUG_LEXER(2)) {
 	    fputs("***  ", dbgout);
@@ -337,7 +355,7 @@
 	txt = end + 2;
 	if (txt >= fin)
 	    break;
-	end = (byte *) strstr((char *)txt, "=?");
+	end = (byte *) memmem((char *)txt, leng-(txt-beg), "=?", 2);
 	copy = end != NULL;
 
 	if (copy) {
